/* ISC (c) 2018+ Jackens * https://github.com/jackens/nanolight */

if (typeof window !== 'undefined') {
  window['module.exports'] = window['module.exports'] || {}
  window.require = window.require || function (id) { return window['module.exports'][id] }
}

(function (R) {
  R = /(".*?(?:[^\\]|\\\\)?")|('.*?(?:[^\\]|\\\\)?')|(`(?:.|\n)*?(?:[^\\]|\\\\)?`)|(\/\*(?:.|\n)*?\*\/)|(<!--(?:.|\n)*?-->)|(\/\/.*?\n)|(\d+(?:\.\d+)?)|([a-zA-Z_$][\w\d$]*)|(.|\n)/

  function E (j) {
    return j.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;')
  }

  function F (j, a, c, k, e, n, s, _) {
    if (a % 10) { return }
    s = 'nl';
    [' nl-a-', ' nl-', ' nl-b-'].forEach(function (p, i) {
      n = c.slice(a + 10 * (i - 1))
      k = n[1] || n[2] || n[3]
      e = n[4] || n[5] || n[6]
      s += p + (k ? 's' : e ? 'c' : n[7] ? 'n' : n[8] ? 'w' + p + 'w-' + n[8] : n[9] ? 'h' + p + 'h-' + n[9].charCodeAt(0).toString(16) : '')
      if (i % 2) {
        _ = k || e || n[7] || n[8] || n[9]
      }
    })
    return _ ? [E(j), '<span class="', s, '">', E(_), '</span>'].join('') : E(j)
  }

  function nanolight (code) {
    return code.split(R).map(F).join('')
  }

  nanolight.cls = function (cls) {
    var a = document.getElementsByClassName(cls || 'nl')
    for (var i = 0; i < a.length; i++) {
      a[i].innerHTML = this(a[i].innerText)
    }
  }

  if (typeof module !== 'undefined') {
    module.exports = nanolight
  } else if (typeof window !== 'undefined') {
    window['module.exports']['nanolight'] = nanolight
  }
})()
